#! /bin/bash


function measure {
    size=$1

    dim=$size
    proj=$size
    slices=10
#    slices=$size


    angle=$(echo "scale=8; 180 / $proj" | bc | awk '{printf "%f", $0}' )
    axis=$(echo "$size / 2" | bc)

    sed \
	-e s/@PROJ@/$proj/g \
	-e s/@DIM@/$dim/g \
	-e s/@SLICES@/$slices/g \
	-e s/@ANGLE@/$angle/g \
	-e s/@AXIS@/$axis/g \
	tmpl.par > cur.par

    res=$(./run.sh 2>&1)
    if [ $? -ne 0 ]; then
	echo "Error executing PyHST, output:"
	echo $res
	echo
	exit -1
    fi

    sec=$(echo "$res" | grep Backprojection | awk -e '{ print $2 }')
    ms=$(echo "scale=3; 1000 * $sec" | bc)

    ops=$(echo "$dim * $dim * $proj" | bc )
    gups=$(echo "scale=3; $ops / $ms / 1000 / 1000" | bc )
    echo "$size $ms $gups"
}

echo "Size Time(ms) GUPS"

for size in `seq 1024 128 4096`; do
    measure $size
    if [ $? -ne 0 ]; then
	echo "Error at size $size. Exiting..."
	echo
	exit -1
    fi
done
