// Unfinished attempt to reduce __syncthreads() to 1 per loop in order to allow better instruction mix.
// Slowing down...  I guess register penalty is high and it is better achieved with multiple groups.
// May be a proper DMA solution could be an option. But I will not go to implement it.
//#define DEBUG_OFFSETS 1	// set to 0 to allow intially interpolations and 1 to disable

#undef KERNEL_NAME
#undef SHMEM_PADDING
#undef SHMEM_SHIFTED_PADDING
#undef SHMEM_ARRAYS
#undef SHMEM_SAMPLING
#undef SIMPLE_SHMEM
#undef SPLIT_SHMEM
#undef REMAP_THREADS
#undef SHMEM_LOAD_ITERATIONS
#undef OVERSAMPLE_MULTIPLIER
#undef GET_CACHE
#undef INTERPOLATE_FROM_CACHE
#undef MIN_BLOCKS
#undef CACHE
#undef FAST_CACHE
#undef FAST_CACHE2
#undef FANCY_ROUND
#undef FANCY_INDEX
#undef FANCY_MINH_CORRECTION
#undef FANCY_CACHE
#undef FANCY_CACHE_MULTIPLIER
#undef SHFL_CACHE
#undef SHMEM_LOAD_FULLWARP
#undef SHMEM_LOAD2
#undef CACHE_POS
#undef CACHE_BLOCK
#undef GET_SINO
#undef BSX
#undef BSY
#undef ASSYMETRY

#define BSX BS
#define BSY BS

#ifdef HST_CACHE_Y
# define CACHE_Y
#endif

#define HST_MACRO_JOIN(a, b) a ## b
#define MK_KERNEL_NAME(name, version) HST_MACRO_JOIN(name, version)

#ifdef OVERSAMPLE
# if OVERSAMPLE == 1
#  define KERNEL_NAME hst_cuda_alu_nn
#  define MIN_BLOCKS HST_NN_MIN_BLOCKS
#  define ASSYMETRY HST_NN_ASSYMETRY
# else
#  define KERNEL_NAME MK_KERNEL_NAME(hst_cuda_alu_oversample, OVERSAMPLE)
#  define MIN_BLOCKS HST_OVERS_MIN_BLOCKS
#  define ASSYMETRY HST_OVERS_ASSYMETRY
# endif
# define SHMEM_SAMPLING OVERSAMPLE			/**< Oversmapling coefficients, how many points to sample per cell */
# undef CACHE_Y
#else
# define KERNEL_NAME hst_cuda_alu_linear
# define SHMEM_SAMPLING 1
# define MIN_BLOCKS HST_LINEAR_MIN_BLOCKS
# define ASSYMETRY HST_LINEAR_ASSYMETRY
#endif
#define SHMEM_SHIFTED_PADDING 0

#ifdef CACHE_Y
# define SHMEM_ARRAYS 2
# define SHMEM_PADDING 1
#else
# define SIMPLE_SHMEM					/**< Use simple ShMem array instead of float2 with 'x' and 'y-x' */
# define SHMEM_ARRAYS 1					/**< Number of shmem arrays (in non SIMPLE mode). For interpolation we may need 2 */
# define SHMEM_PADDING 0				/**< We need extra byte in the end of shmem array if we compute (y-x) */
#endif

#if SHMEM_SAMPLING > 1
# define REMAP_THREADS					/**< Localise accesses (needed for wide Oversampling kernels to avoid cache misses */
#endif

#if SHMEM_SAMPLING == 4 
# define OVERSAMPLE_MULTIPLIER 0.25f
#elif SHMEM_SAMPLING > 1
# define OVERSAMPLE_MULTIPLIER (1.f / OVERSAMPLE)
#else
# define OVERSAMPLE_MULTIPLIER 1
#endif


#ifdef HST_TUNE_SHMEM
	/* This is pretty much useless. We optimize access to ShMem cache during the writting phase, but
	this costs us extra instructions (need to compute 2 addresses instead of 1). 
	- On Fermi (and likely all other architectures float1 is compute bound. For float* we enforce it
	anyway.
	- Besides, using 3D arrays is significantly more optimal than addressing manually in linear array.
	So, the clever tricks will also not work.
	- Shifted padding is to extend array at different (non-last) dimmension to ensure no bank conflicts
	in 32-bit mode. */
# ifndef SIMPLE_SHMEM
#  if SLICE_BLOCK == 1
#    undef SHMEM_SHIFTED_PADDING
#    define SHMEM_SHIFTED_PADDING SHMEM_PADDING
#    undef SHMEM_PADDING
#    define SHMEM_PADDING 0
#  endif
#  define SIMPLE_SHMEM
# endif /* ! SIMPLE_SHMEM */
#endif

#if SLICE_BLOCK > 1
# define SIMPLE_SHMEM
# if SLICE_BLOCK == 4
#  if  !defined(HST_OPTIMIZE_KEPLER) 
#   define SPLIT_SHMEM
#  endif
# endif
#endif

    // We don't need padding if shfl used to compute (x+1)-x
#if defined(HST_SHFL_CACHE)&&defined(CACHE_Y)&&!defined(SIMPLE_SHMEM)
# define SHFL_CACHE
# undef SHMEM_PADDING
# define SHMEM_PADDING 0
# define REMAP_THREADS
#endif




#if PPT == 1
# if SHMEM_SAMPLING == 4
#  define SHMEM_LOADS (6)
# else
#  define SHMEM_LOADS (2 * SHMEM_SAMPLING)
# endif
# define SHMEM_LOADS_ITERATIONS SHMEM_LOADS
#else
# define SHMEM_LOADS (3 * SHMEM_SAMPLING * (PPT / 2))

# if defined(HST_SHMEM64)&&((SHMEM_SAMPLING * PPT) >= 4)&&(PROJ_BLOCK <= 8)
#  if ((SHMEM_SAMPLING * PPT) >= 8)&&(SLICE_BLOCK == 1)&&defined(SIMPLE_SHMEM)
#    define SHMEM_LOAD2						/* Combine two texture fetches to 1 64-bit shmem store */
#    define SHMEM_LOAD_FULLWARP ((SHMEM_SAMPLING * PPT) / 4)	/* Counts number of rows we can load simultaneously */
#    define SHMEM_LOAD_ITERATIONS (SHMEM_LOADS  / SHMEM_LOAD_FULLWARP / 2)  /* Use 32-threads (or more) for loading data, this limits projections to 8 */
#  else
#    ifdef SHFL_CACHE
#     define SHMEM_LOAD_FULLWARP 2				/* Counts number of rows we can load simultaneously */
#    else
#     define SHMEM_LOAD_FULLWARP ((SHMEM_SAMPLING * PPT) / 2)	/* Counts number of rows we can load simultaneously */
#    endif
#    define SHMEM_LOAD_ITERATIONS (SHMEM_LOADS / SHMEM_LOAD_FULLWARP)
#  endif
# else
#  define SHMEM_LOAD_ITERATIONS (SHMEM_LOADS)
# endif
#endif




#ifdef SIMPLE_SHMEM
# define CACHE(proj, bin, c) cache[c][proj][bin]
# define FANCY_CACHE(proj, bin, c) (*(float*)(((char*)(&(cache[c][proj][0]))) + bin))
# define FANCY_CACHE_MULTIPLIER (sizeof(vfloat))
#else 
# define CACHE(proj, bin, c) cache[proj][bin].comp(c)
# define CACHE2(proj, bin) cache[proj][bin]
# define FANCY_CACHE(proj, bin, c) (*(float*)(((char*)(&(cache[proj]))) + bin + c))
# define FANCY_CACHE2(proj, bin) (*(float2*)(((char*)(&(cache[proj]))) + bin))
# define FANCY_CACHE_MULTIPLIER (2 * sizeof(float))
#endif

#define FANCY_MINH_CORRECTION(x) (x)
#ifdef OVERSAMPLE
# ifdef HST_OVERS_FANCY_ROUND
#  ifdef HST_OVERS_FANCY_INDEX
#   define FANCY_INDEX
//#  define FANCY_ROUND(idx, h) ({idx = FANCY_CACHE_MULTIPLIER * (int)(h); })
#   define FANCY_ROUND(idx, h) ({float fh = FANCY_CACHE_MULTIPLIER * ((h) + exp23) - (FANCY_CACHE_MULTIPLIER - 1) * exp23; idx = __float_as_int(fh) - 0x4B000000; })
#  else /* NO FANCY_INDEX */
#   define FANCY_ROUND(idx, h) ({float fh = (h) + exp23; idx = __float_as_int(fh) - 0x4B000000; })
#  endif /* NO FANCY_INDEX */
# endif /* FANCY_ROUND */
#else /* NOT OVERSAMPLE */
# ifdef HST_LINEAR_FANCY_FLOOR
#  ifdef HST_LINEAR_FANCY_INDEX
#   define FANCY_INDEX
#   define FANCY_ROUND(idx, diff, h) ({ float newh = h - 0.499999f; float fh = newh + exp23; diff = (fh - exp23); fh = FANCY_CACHE_MULTIPLIER * fh - (FANCY_CACHE_MULTIPLIER - 1) * exp23; idx = (*(int*)(&fh)) - (0x4B000000 + FANCY_CACHE_MULTIPLIER); })
#  else /* NO FANCY_INDEX */
#   define FANCY_ROUND(idx, diff, h) ({ float newh = h - 0.499999f; float fh = newh + exp23; diff = (fh - exp23); idx = (*(int*)(&fh)) - 0x4B000001; })
#  endif
	// For proper rounding we need values above 1. So, we artificaly add 1 to array offset. We will remove it during the rounding.
#  undef FANCY_MINH_CORRECTION
#  define FANCY_MINH_CORRECTION(x) ((x) - 1.f)
# endif
#endif


#ifdef FANCY_INDEX
# define FAST_CACHE FANCY_CACHE
# define FAST_CACHE2 FANCY_CACHE2
#else
# define FAST_CACHE CACHE
# define FAST_CACHE2 CACHE2
#endif





#ifdef SIMPLE_SHMEM
# ifdef CACHE_Y
#  ifdef SPLIT_SHMEM
#   define GET_CACHE(v1, v2, minh, i) ({ int bin = (minh); float2 vxy, vzw; vxy = FAST_CACHE(i, bin, 0); vzw = FAST_CACHE(i, bin, 2); v1 = mkf4(vxy, vzw);  vxy = FAST_CACHE(i, bin, 1); vzw = FAST_CACHE(i, bin, 3); v2 = mkf4(vxy, vzw); })
#  else /* SPLIT_SHMEM */
#   define GET_CACHE(v1, v2, minh, i) ({ int bin = (minh); v1 = FAST_CACHE(i, bin, 0); v2 = FAST_CACHE(i, bin, 1); })
#  endif /* SPLIT_SHMEM */
# else
#  ifdef SPLIT_SHMEM
#   define GET_CACHE(v, minh, i) ({ int bin = (minh); float2 vxy, vzw; vxy = FAST_CACHE(i, bin, 0); vzw = FAST_CACHE(i, bin, 1); v = mkf4(vxy, vzw); })
#  else /* SPLIT_SHMEM */
#   define GET_CACHE(v, minh, i) ({ int bin = (minh); v = FAST_CACHE(i, bin, 0); })
#  endif /* SPLIT_SHMEM */
# endif
#else /* SIMPLE_SHMEM */
# define GET_CACHE(v1, v2, minh, i) ({ int bin = (minh); float2 c = FAST_CACHE2(i, bin); v1 = c.x; v2 = c.y; })
#endif /* SIMPLE_SHMEM */

#if defined(HST_MEM_FETCHES)&&(SHMEM_SAMPLING == 1)
# define HST_FETCH_VAR(var, val) int var = (val); 	// floor?
# define GET_SINO(bin, proj) sino[(proj)*bin_pitch + (((bin)<num_bins)?(bin):0)]
#else  /* HST_MEM_FETCHES */
# define HST_FETCH_VAR(var, val) float var = (val) + 0.5f;
# define GET_SINO(bin, proj) hst_tex(texptr, bin, proj);
#endif /* HST_MEM_FETCHES */

#ifdef DEBUG_OFFSETS
# undef GET_SINO
# define GET_SINO(bin, proj)  {0.f}
#endif

#if defined(CACHE_Y)
# define INTERPOLATE_FROM_CACHE(i, idx) ({ vfloat v1, v2; GET_CACHE(v1, v2, idx, i); (v1 + diff * v2); })
#elif defined(OVERSAMPLE)
# define INTERPOLATE_FROM_CACHE(i, idx) ({ vfloat v; GET_CACHE(v, idx, i); v; })
#else  /* UNCACHED_Y */
# define INTERPOLATE_FROM_CACHE(i, idx) ({ vfloat v1, v2; int _idx = idx; GET_CACHE(v1, _idx, i); GET_CACHE(v2, _idx + 1, i); (v1 + diff * (v2 - v1)); })
#endif /* OVERSAMPLE */


#ifdef SHMEM_LOAD_FULLWARP
# ifdef SHMEM_LOAD2
#  define CACHE_POS(i) (2 * SHMEM_LOAD_FULLWARP * i * BSX + 2 * cache_tidx)
# else
#  define CACHE_POS(i) (SHMEM_LOAD_FULLWARP * i * BSX + cache_tidx)
# endif
#else
# define CACHE_POS(i) (i * BSX + cache_tidx)
#endif

#if defined(HST_CACHE_MINH)
# ifdef HST_PRECOMPUTE_OFFSETS
#  define CACHE_IDX(p) (proj_offset + (p))
# else
#  define CACHE_IDX(p) (subproj * PROJ_BLOCK + (p))
# endif
#else
# define CACHE_IDX(p) (p)
#endif

#if HST_LINEAR_CACHE_BLOCK > (BSX * BSY / ASSYMETRY)
# define CACHE_BLOCK (BSX * BSY / ASSYMETRY)
#else 
# define CACHE_BLOCK HST_LINEAR_CACHE_BLOCK
#endif


#if defined(HST_HYBRID) && !defined(OVERSAMPLE)
 __device__
 static 
#else
__global__
static 
# if MIN_BLOCKS > 0
__launch_bounds__(BSX * BSY / ASSYMETRY, MIN_BLOCKS)
# endif
#endif
void KERNEL_NAME(cudaTextureObject_t texptr, const float * __restrict__ g_all, const vfloat * __restrict__ sino, int num_proj, int num_bins, int bin_pitch, vfloat *d_SLICE, float apos_off_x, float apos_off_y, int batch) {
#ifdef HST_SQUARE_PPT
    vfloat res[PPT][PPT] = {0.f};
#else
# define YSIZE (ASSYMETRY * PPT * PPT)
# define YSTEP (BSY / (ASSYMETRY * PPT))
    vfloat res[YSIZE] = {0.f};
#endif

    const float exp23 = exp2(23.f);

    const int tidx = threadIdx.x;
    const int tidy = threadIdx.y;

#ifdef SHMEM_LOAD_FULLWARP
	// Should not happen for 8x8 blocks (should be no conflicts with ppt=2)
    const int cache_tidx = (tidy%SHMEM_LOAD_FULLWARP)*16 + tidx;
    const int cache_tidy = tidy/SHMEM_LOAD_FULLWARP;
#else
    const int cache_tidx = tidx;
    const int cache_tidy = tidy;
#endif

    const int bidx = PPT * blockIdx.x * BSX;
    const int bidy = batch + PPT * blockIdx.y * BSY;

	// We get centers offsetted by 0.5f to get in the pixel centers as expected by texture engine
    const float off_x = apos_off_x - 0.5f;
    const float off_y = apos_off_y - 0.5f;

    const float bx = bidx + off_x;
    const float by = bidy + off_y;

#ifdef HST_SQUARE_PPT
# ifdef REMAP_THREADS
	// Also should not happen for 8x8 blocks (but we can reconsider)
#  if (BSX == 16)&&(BSY == 16)
    const int sidx = 4 * (threadIdx.y % 4) + (threadIdx.x % 4);
    const int sidy = 4 * (threadIdx.y / 4) + (threadIdx.x / 4);
#  elif (BSX == 8)&&(BSY == 8)
    const int sidx16 = 4 * (threadIdx.y % 4) + (threadIdx.x % 4);
    const int sidx = sidx16 % 8;
    const int sidy = 4 * (sidx16 / 8) + 2 * (threadIdx.y / 4) + (threadIdx.x / 4);
#  else
#   error "Specified block size is not supported"
#  endif
# else
    const int sidx = tidx;
    const int sidy = tidy;
# endif
#else
# if PPT == 4
    const int sidx = 4 * threadIdx.y + (threadIdx.x % 4);
    const int sidy = (threadIdx.x / 4);
# elif PPT == 2
    const int sidx = 4 * (threadIdx.y % 8) + (threadIdx.x % 4);
    const int sidy = 4 * (threadIdx.y / 8) + (threadIdx.x / 4);
# else
#   error "Specified PPT is not supported"
# endif
#endif

    const int idx = bidx + sidx; 
    const int idy = bidy + sidy; 

    const float x = SHMEM_SAMPLING * (idx + off_x);
    const float y = SHMEM_SAMPLING * (idy + off_y);

#ifdef DEBUG_OFFSETS
    int debug_run = !DEBUG_OFFSETS;
#endif 

#ifdef SIMPLE_SHMEM
# ifdef SPLIT_SHMEM
    __shared__  float2   cache[2 * SHMEM_ARRAYS][PROJ_BLOCK + SHMEM_SHIFTED_PADDING][SHMEM_LOADS * BSX + SHMEM_PADDING];
# else
    __shared__  vfloat   cache[SHMEM_ARRAYS][PROJ_BLOCK + SHMEM_SHIFTED_PADDING][SHMEM_LOADS * BSX + SHMEM_PADDING];
# endif
#else 
    __shared__  float2  _cache[2 * PROJ_BLOCK][SHMEM_LOADS * BSX + SHMEM_PADDING];
	typedef float2   cache_t[SHMEM_LOADS * BSX + SHMEM_PADDING];
//    __shared__ cache_t *_cache[2];
    cache_t *cache = (cache_t*)&_cache[0][0];
#endif


#ifdef HST_CACHE_MINH
     const int wrapid = (tidy&1) * 16 + tidx;
    __shared__ float2 cache_sin[CACHE_BLOCK];
    __shared__ float  cache_subh[CACHE_BLOCK];
    __shared__ float  cache_minh[CACHE_BLOCK];		// For mem-fetches we actually can store in unsigned char (but that would involve back-conversion for texture fetches)

    int tminhx = tidy * BSX + tidx;
#else
# ifdef HST_CACHE_SUBH
    __shared__  float   cache_subh[PROJ_BLOCK];
# endif
# ifdef HST_CACHE_SIN
    __shared__  float2  cache_sin[PROJ_BLOCK];
# endif
#endif

    int cache_id = 0;
    HST_FETCH_VAR(projf, cache_tidy);
#ifdef HST_CACHE_MINH
    for (int proje=0; proje<num_proj; /*proje += PROJ_BLOCK*/) {
      const int last_proj = min(num_proj, proje + CACHE_BLOCK);

      if (tminhx < CACHE_BLOCK) {
        int g_proj = proje + tminhx;
# if defined(HST_GMEM_CONST)
	const float4 all = { g_all[g_proj], g_all[MAXNPROJECTIONS + g_proj], g_all[2 * MAXNPROJECTIONS + g_proj], g_all[3 * MAXNPROJECTIONS + g_proj] };
# elif defined(HST_C_TRIG)
	const float4 all = (float4){c_trig[proje + p].x, c_trig[proje + p].y, c_ofst[proje + p].x, c_ofst[proje + p].y };
# else
	const float4 all = c_all[g_proj];
# endif

#if !defined(HST_GMEM_CONST)&&defined(HST_C_TRIG)
//	const float g_minh = floor(__fmaf_rz(-by, all.y, __fmaf_rz(bx, all.x, all.w)));
	const float g_minh = floor(bx * all.x - by * all.y + all.w);
	cache_subh[tminhx] = all.z - SHMEM_SAMPLING * g_minh;
#else
	const float g_minh = floor(all.z + bx * all.x - by * all.y + all.w);
	cache_subh[tminhx] = SHMEM_SAMPLING * (all.z - FANCY_MINH_CORRECTION(g_minh));
#endif
	cache_minh[tminhx] = g_minh;
	cache_sin[tminhx] = (float2){ all.x, all.y};
      }

      __syncthreads();


# ifdef HST_OPTIMIZE_KEPLER 
      float regcache_subh[CACHE_BLOCK / 32];
#pragma unroll
      for (int i = 0; i < (CACHE_BLOCK / 32); i ++) {
        regcache_subh[i] = cache_subh[32 * i + wrapid];
      }
# endif
//#pragma unroll 1
      for (int subproj = 0; proje < last_proj; subproj++, proje += PROJ_BLOCK) {
# ifdef HST_PRECOMPUTE_OFFSETS
	 const int proj_offset = subproj * PROJ_BLOCK;
	 const int proj_var = (proj_offset) >> 5;
	 const int proj_idx = (proj_offset)&0x1F;
# endif

#else

//***** xxxx ******/
	    float4 all = c_all[cache_tidy];
	    float minh = floor(all.z + bx * all.x - by * all.y + all.w);
#if defined(SHFL_CACHE)

	    HST_FETCH_VAR(binf, minh);

	    const int bin_start = SHMEM_LOAD_ITERATIONS * cache_tidx;
	    float v1 = GET_SINO(binf + bin_start, projf);
	    float v = v1;
#pragma unroll
	    for (int i = 0; i < (SHMEM_LOAD_ITERATIONS - 1); i++) {
		const int pos = bin_start + i;
		const float vnext = GET_SINO(binf + pos + 1, projf);
		CACHE2(cache_tidy, pos) = (float2){ v, vnext - v };
		v = vnext;
	    }
# ifdef SHMEM_LOAD_FULLWARP
	    v1 = __shfl_down(v1, 1, 32);
# else
	    v1 = __shfl_down(v1, 1, BSX);
# endif
	    CACHE2(cache_tidy, bin_start + SHMEM_LOAD_ITERATIONS - 1) = (float2){ v, (v1 - v) };
#endif

	    projf += PROJ_BLOCK;
//******* xxxxx *****/

	__syncthreads();

#pragma unroll 1
    for (int proje=0; proje<num_proj; proje += PROJ_BLOCK) {
#endif

	cache_id = !cache_id;
#ifndef SIMPLE_SHMEM
	cache = (cache_t*)&_cache[(cache_id?0:PROJ_BLOCK)][0];
#endif


	if (cache_tidy < PROJ_BLOCK) {
#ifdef HST_CACHE_MINH
	    const float minh = cache_minh[subproj * PROJ_BLOCK + cache_tidy];
#else // ! HST_CACHE_MINH

	    if (cache_tidx == 0) {
# ifdef HST_CACHE_SUBH
#  ifdef HST_C_TRIG
		cache_subh[cache_tidy] = all.z - SHMEM_SAMPLING * minh;
#  else
		cache_subh[cache_tidy] = SHMEM_SAMPLING * (all.z - FANCY_MINH_CORRECTION(minh));
#  endif
# endif 

# ifdef HST_CACHE_SIN
		cache_sin[cache_tidy] = (float2){ all.x, all.y};
# endif
	    }

	    const int next_proje = proje + PROJ_BLOCK;
	    if (next_proje < num_proj) {
# ifdef HST_C_TRIG
	    float4 all = (float4){c_trig[next_proje + cache_tidy].x, c_trig[next_proje + cache_tidy].y, c_ofst[next_proje + cache_tidy].x, c_ofst[next_proje + cache_tidy].y };
//	    float minh = floor(__fmaf_rz(-by, all.y, __fmaf_rz(bx, all.x, all.w)));
	    float minh = bx * all.x - by * all.y + all.w;
# else
		// cache_tidy is either equal to tidy or to tidy/2
	    int next_proje = proje + PROJ_BLOCK;
	    float4 all = c_all[next_proje + cache_tidy];
	    float minh = floor(all.z + bx * all.x - by * all.y + all.w);
# endif

#endif // ! HST_CACHE_MINH


	    HST_FETCH_VAR(binf, minh);

#if defined(SHFL_CACHE)
	    const int bin_start = SHMEM_LOAD_ITERATIONS * cache_tidx;
	    float v1 = GET_SINO(binf + bin_start, proje + projf);
	    float v = v1;
#pragma unroll
	    for (int i = 0; i < (SHMEM_LOAD_ITERATIONS - 1); i++) {
		const int pos = bin_start + i;
		const float vnext = GET_SINO(binf + pos + 1, proje + projf);
		CACHE2(cache_tidy, pos) = (float2){ v, vnext - v };
		v = vnext;
	    }
# ifdef SHMEM_LOAD_FULLWARP
	    v1 = __shfl_down(v1, 1, 32);
# else
	    v1 = __shfl_down(v1, 1, BSX);
# endif
	    CACHE2(cache_tidy, bin_start + SHMEM_LOAD_ITERATIONS - 1) = (float2){ v, (v1 - v) };

#else
# pragma unroll
	    for (int i = 0; i < SHMEM_LOAD_ITERATIONS; i++) {
		int pos = CACHE_POS(i);

		vfloat v = GET_SINO(binf + OVERSAMPLE_MULTIPLIER * pos, proje + projf);
# if defined(SPLIT_SHMEM)
		CACHE(cache_tidy, pos, 0) = (float2){v.x, v.y};
		CACHE(cache_tidy, pos, SHMEM_ARRAYS) = (float2){v.z, v.w};
# elif defined(SHMEM_LOAD2)
		float v2 = GET_SINO(binf + OVERSAMPLE_MULTIPLIER * (pos + 1), proje + projf);
		*(float2*)&CACHE(cache_tidy, pos, 0) = (float2){v, v2};
# else
		CACHE(cache_tidy, pos, 0) = v;
# endif
	    }

# ifdef CACHE_Y
	    // We don't need to sync all groups, but prevent optimizer from reshuffling the instructions,
	    // __syncthreads() will require to break the (to be executed by all threads) and slightly slower
	__threadfence_block();

# pragma unroll
	    for (int i = 0; i < SHMEM_LOAD_ITERATIONS; i++) {
		int pos = CACHE_POS(i);
		CACHE(cache_tidy, pos, 1) = CACHE(cache_tidy, pos + 1, 0) - CACHE(cache_tidy, pos, 0);
#  ifdef SPLIT_SHMEM
		CACHE(cache_tidy, pos, 3) = CACHE(cache_tidy, pos + 1, 2) - CACHE(cache_tidy, pos, 2);
#  endif
	    }
# endif // CACHE_Y
#endif

	}
	}

	cache_id = !cache_id;
#ifndef SIMPLE_SHMEM
	cache = (cache_t*)&_cache[(cache_id?0:PROJ_BLOCK)][0];
#endif

//	    __syncthreads();

#ifdef HST_FANCY_ROUND
# pragma unroll 4	// over-unrolling hurts performance (but 4 is need to allow joining accesses to subh_cache)
#else
# pragma unroll 2
#endif
	for (int p = 0; p < PROJ_BLOCK; p++) {
#if !defined(HST_CACHE_SUBH)
# ifdef HST_C_TRIG
	    const float4 all = (float4){c_trig[proje + p].x, c_trig[proje + p].y, c_ofst[proje + p].x, c_ofst[proje + p].y };
# else
	    const float4 all = c_all[proje + p];
# endif
#elif !defined(HST_CACHE_SIN)
# ifdef HST_C_TRIG
	    const float2 all = c_trig[proje + p];
# else
	    const float4 all = c_all[proje + p];
# endif
#endif

#if defined(HST_CACHE_SIN)
	    const float2 sincos = cache_sin[CACHE_IDX(p)];
#else
# define sincos all
#endif

#if defined(HST_CACHE_MINH) && defined(HST_OPTIMIZE_KEPLER)
# ifdef HST_PRECOMPUTE_OFFSETS
	    float subh = __shfl(regcache_subh[proj_var], proj_idx + p, 32);
# else
	    float subh = __shfl(regcache_subh[subproj * PROJ_BLOCK >> 5], (subproj * PROJ_BLOCK + p)&0x1F, 32);
# endif
#elif defined(HST_CACHE_SUBH)
	    float subh = cache_subh[CACHE_IDX(p)];
#else
# ifdef HST_C_TRIG
//	    const float minh = floor(__fmaf_rz(-by, all.y, __fmaf_rz(bx, all.x, all.w)));
	    float minh = floor(bx * all.x - by * all.y + all.w);
	    const float subh = all.z - SHMEM_SAMPLING * minh;
# else
	    float minh = floor(all.z + bx * all.x - by * all.y + all.w);
	    float subh = SHMEM_SAMPLING * (all.z - FANCY_MINH_CORRECTION (minh));
# endif
#endif
//	    subh += SHMEM_SAMPLING_MULTIPLIER * (x * sincos.x - y * sincos.y);
//	    subh = (subh + x * sincos.x) - y * sincos.y;
	    subh = __fmaf_rz(-y, sincos.y, __fmaf_rz(x, sincos.x, subh));


#ifdef HST_SQUARE_PPT
# pragma unroll
	    for (int i = 0; i < PPT; i++) {
# pragma unroll
	      for (int j = 0; j < PPT; j++) {
		const float h = subh + (j * BSX * SHMEM_SAMPLING) * sincos.x - (i * BSY * SHMEM_SAMPLING) * sincos.y;
#else
# pragma unroll
            for (int i = 0; i < YSIZE; i++) {
                const float h = (subh  - i * SHMEM_SAMPLING * YSTEP * sincos.y);
#endif

#ifdef OVERSAMPLE
# ifdef FANCY_ROUND
		int idx;
		FANCY_ROUND(idx, h);
# else
		int idx = (int)(h + 0.5f);	// DS!!! 0.5f can go to subh [OVERSAMPLE NON FANCY]
		//int idx = (int)rint(h);
# endif
#else
# ifdef FANCY_ROUND
		int idx; float diff;
		FANCY_ROUND(idx, diff, h);
# else
		float diff = floorf(h);
		int idx = (int)diff;
# endif
		diff = h - diff;
#endif


#ifdef DEBUG_OFFSETS
		if (debug_run > 0) {
#endif

#ifdef HST_SQUARE_PPT
		    res[i][j] += INTERPOLATE_FROM_CACHE(p, idx); 
#else
		    res[i] += INTERPOLATE_FROM_CACHE(p, idx); 
#endif

#ifdef DEBUG_OFFSETS
		}

		if ((debug_run >=0 )&&((proje + p)==0)) { 
# ifdef HST_SQUARE_PPT
		    *(float*)(&res[i][j]) = idx;
# else
		    *(float*)(&res[i]) = idx;
# endif
		    debug_run = -1;
		}
#endif
#ifdef HST_SQUARE_PPT
	      }
#endif
            }
    	} // p

	__syncthreads();
#ifdef HST_CACHE_MINH
      }
#endif
    }


#ifdef HST_SQUARE_PPT
# pragma unroll
    for (int i = 0; i < PPT; i++) {
# pragma unroll
	for (int j = 0; j < PPT; j++) {
	    d_SLICE[BSX * PPT * gridDim.x * (idy + i * BSY) + idx + j * BSX] = res[i][j];
	}
    }
#else
# pragma unroll
    for (int i = 0; i < YSIZE; i++) {
	d_SLICE[BSX * PPT * gridDim.x * (idy + i * YSTEP) + idx] = res[i];
    }
#endif

}

