/**
 * Something old
 */
#undef subh_cache
#define subh_cache(subh) cache[(int)(subh)]
__kernel void hst_backproject_dma_oversample4(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all, 
    __local float *shared
    ) {

    __local float *cache = shared;						// cache[BLOCK_SIZE_Y][12 * BLOCK_SIZE_X + 1];

    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int bidx = 2 * get_group_id(0) * BLOCK_SIZE;
//    const int bidy = 2 * get_group_id(1) * BLOCK_SIZE;
    const int bidy = 2 * (get_global_id(1) - get_local_id(1));

    const float bx = bidx + off_x;
    const float by = bidy + off_y;


    const int rtidy = (tidy - 8) * 2 + tidx / 8;
    
        // This is subblocks within block (big block is 16x16, subblock is 4x4 completely contained in a single wrap)
    const int sbidx = rtidy % 4;
    const int sbidy = rtidy / 4;
    
    const int stidx = tidx % 8;
    const int stidy = 0; // tidx / 8;
    
    const int sidx = - (sbidx * 8 + stidx);
    const int sidy = sbidy * 8; // + 4 * stidy;

    const int idx = bidx - sidx;
    const int idy = bidy + sidy;
    
    const int slice_width = 2 * get_global_size(0);

    float4 res = {0.f, 0.f, 0.f, 0.f};
    float4 res2 = {0.f, 0.f, 0.f, 0.f};

    int buf = 0;

        if (tidy < 8) {
            float4 all = c_all[tidy];
	    float minh = all.z + bx * all.x - by * all.y + all.w;

#pragma unroll 12
	    for (int i = 0; i < 12; i++) {
	        int pos = i * BLOCK_SIZE + tidx;
	        cache[tidy * (12 * BLOCK_SIZE + 1) + pos] = read_imagef(sinogram, volumeSampler, (float2)(minh + 0.25f*pos, tidy + 0.5f)).x;
	    }
	}

    int proje = 0;
    while (1) {
        if (tidy > 7) {
            const int line = (buf?8:0);
#pragma unroll 8
	    for (int i = 0; i < 8; i++) {
                float4 all = -4 * c_all[proje + i];

                //float subh = (-sidx * all.x - sidy * all.y) - all.w;
                float subh = mad(193.f, line + i, mad(sidx, all.x, mad(sidy, all.y, all.w)));
            
	        res.x += subh_cache(subh);
	        res.y += subh_cache(mad(1.f, all.y, subh));
	        res.z += subh_cache(mad(2.f, all.y, subh));
	        res.w += subh_cache(mad(3.f, all.y, subh));

	        res2.x += subh_cache(mad(4.f, all.y, subh));
	        res2.y += subh_cache(mad(5.f, all.y, subh));
	        res2.z += subh_cache(mad(6.f, all.y, subh));
	        res2.w += subh_cache(mad(7.f, all.y, subh));
	    }
        }
        
        proje += 8;
        if (proje >= num_proj) break;
        buf = !buf;

        if (tidy < 8) {
	    const int line = tidy + (buf?8:0);
	    int proj = proje + tidy;
            float4 all = c_all[proj];
	    float minh = all.z + bx * all.x - by * all.y + all.w;

#pragma unroll 12
	    for (int i = 0; i < 12; i++) {
	        int pos = i * BLOCK_SIZE + tidx;
	        cache[line * (12 * BLOCK_SIZE + 1) + pos] = read_imagef(sinogram, volumeSampler, (float2)(minh + 0.25f*pos, proj + 0.5f)).x;
	    }
	}
        
        barrier(CLK_LOCAL_MEM_FENCE);
    }

    if (tidy > 7) {
        slice[slice_width * (idy    ) + idx] = res.x;
        slice[slice_width * (idy + 1) + idx] = res.y;
        slice[slice_width * (idy + 2) + idx] = res.z;
        slice[slice_width * (idy + 3) + idx] = res.w;

        slice[slice_width * (idy + 4) + idx] = res2.x;
        slice[slice_width * (idy + 5) + idx] = res2.y;
        slice[slice_width * (idy + 6) + idx] = res2.z;
        slice[slice_width * (idy + 7) + idx] = res2.w;
    }

}


/**
 * Manual unrolling
 */
__kernel void hst_backproject_4ppt_tex(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all/*, 
    __local float *shared*/
    ) {

    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int sidx = tidx;
    const int sidy = tidy;

    const int idx = PPT * get_group_id(0) * get_local_size(0) + sidx;
    const int idy = PPT * (get_global_id(1) - get_local_id(1)) + sidy;

    const float x = idx + off_x;
    const float y = idy + off_y;

    const int slice_width = PPT * get_global_size(0);

    float res[PPT][PPT] = {{0}};

    for (int proj = 0; proj < num_proj; proj++) {
        float4 all = c_all[proj];
        all.y = - all.y;
        float subh = mad(x, all.x, mad(y, all.y, all.z));

#pragma unroll 4
        for (int i = 0; i < PPT; i++) {
#pragma unroll 4
            for (int j = 0; j < PPT; j++) {
                res[i][j] += read_imagef(sinogram, volumeSampler, (float2)(subh + i * get_local_size(1) * all.y + j * get_local_size(0) * all.x, proj + .5f)).x;
            }
        }
    }


#pragma unroll 4
    for (int i = 0; i < PPT; i++) {
#pragma unroll 4
        for (int j = 0; j < PPT; j++) {
            slice[(idy + get_local_size(1) * i) * slice_width +  idx + get_local_size(0) * j] = res[i][j];
        }
    }
}



__kernel void hst_backproject_6ppt_tex(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all/*, 
    __local float *shared*/
    ) {

    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int sidx = tidx;
    const int sidy = tidy;

    const int idx = PPT * get_group_id(0) * get_local_size(0) + sidx;
    const int idy = PPT * (get_global_id(1) - get_local_id(1)) + sidy;

    const float x = idx + off_x;
    const float y = idy + off_y;

    const int slice_width = PPT * get_global_size(0);

    float res[PPT][PPT] = {{0}};

    for (int proj = 0; proj < num_proj; proj++) {
        float4 all = c_all[proj];
        all.y = - all.y;
        float subh = mad(x, all.x, mad(y, all.y, all.z));

#pragma unroll 6
        for (int i = 0; i < PPT; i++) {
#pragma unroll 6
            for (int j = 0; j < PPT; j++) {
                res[i][j] += read_imagef(sinogram, volumeSampler, (float2)(subh + i * get_local_size(1) * all.y + j * get_local_size(0) * all.x, proj + .5f)).x;
            }
        }
    }


#pragma unroll 6
    for (int i = 0; i < PPT; i++) {
#pragma unroll 6
        for (int j = 0; j < PPT; j++) {
            slice[(idy + get_local_size(1) * i) * slice_width +  idx + get_local_size(0) * j] = res[i][j];
        }
    }
}




/**
 * Old KeplerTex with inversed axes. For some reason is faster on AMD
 */

#define SHMEM_STEP 16
__kernel void hst_backproject_gcn_tex(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all, 
    __local float *cache
) {
    float h;
    float res[4][4] = {{0}};

    __local float *buf = cache;
    __local float *fill = cache + 16 * SHMEM_STEP;
    __local float *fin = fill;// + 56;
    
    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int bidx = get_group_id(0) * get_local_size(0);
    const int bidy = get_group_id(1) * get_local_size(1);

    const int sidx = tidy % 4;
    const int sidy = tidy / 4;

    const float x = bidx + sidx + off_x;
    const float y = bidy + sidy + off_y;

    const float projf = tidx + 0.5f;

    for (int proje=0; proje<num_proj; proje+=16) {
        const float4 all = c_all[proje+tidx];
        h = all.z + x * all.x - y * all.y;

#pragma unroll 4
        for (int i = 0; i < 4; i++) {
#pragma unroll 4
	    for (int j = 0; j < 4; j++) {
	        float subh = h + 4 * j * all.x - 4 * i * all.y;
		res[i][j] += read_imagef(sinogram, volumeSampler, (float2)(subh, proje + projf)).x;
	    }
        }

    }

#pragma unroll 4
    for (int i = 0; i < 4; i++) {
#pragma unroll 4
	for (int j = 0; j < 4; j++) {
            buf[tidy * SHMEM_STEP + tidx] = res[i][j];

    	    barrier(CLK_LOCAL_MEM_FENCE);

            volatile __local float *ptr = buf + SHMEM_STEP * tidy;
            for (int k=8; k>=1; k/=2)
                ptr[tidx] += ptr[tidx+k];
            float val = ptr[0];

            const int rx = 4 * j + tidy%4;
            const int ry = 4 * i + tidy/4;

            if (!tidx) {
                fin[ry * SHMEM_STEP + rx] = val;
            }

    	    barrier(CLK_LOCAL_MEM_FENCE);
        }
    }


    const int idx = bidx + tidx;
    const int idy = bidy + tidy;

    slice[get_global_size(0) * idy + idx] = fin[tidy * SHMEM_STEP + tidx];

}

/**
 * Minimal effect. 
 */
__kernel void hst_backproject_squarewarps_gpu(const int num_proj,
    const int num_bins,
    const float off_x,
    const float off_y,
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *all_table)
{
    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int bidx = get_group_id(0);
    const int bidy = get_group_id(1);

    const int sidx = 4 * (tidy % 4) + tidx % 4;
    const int sidy = 4 * (tidy / 4) + tidx / 4;

    const int sbidx = 4 * (bidy % 4) + 2 * ((bidx / 4) % 2) + bidx % 2;
    const int sbidy = 4 * (bidy / 4) + 2 * ((bidx / 4) / 2) + (bidx / 2) % 2;


    const int idx = sbidx * get_local_size(0) + sidx;
    const int idy = sbidy * get_local_size(1) + sidy;

    const int slice_width = get_global_size(0);

    float h;
    float bx = idx + off_x;
    float by = -(idy + off_y);
    float sum = 0.0f;

    for(int proj = 0; proj < num_proj; proj++) {
	h = mad(by, all_table[proj].y, mad(bx, all_table[proj].x, all_table[proj].z)); 
	sum += read_imagef(sinogram, volumeSampler, (float2)(h, proj + 0.5f)).x;
    }
    
    slice[idy*slice_width + idx] = sum;
}


/**
  * Useless, compiler does it anyway
  */
#define SUMS 4
__kernel void hst_backproject_parallel_gpu(const int num_proj,
    const int num_bins,
    const float off_x,
    const float off_y,
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *all_table)
{
    const int idx = get_global_id(0);
    const int idy = get_global_id(1);
    const int slice_width = get_global_size(0);

    float bx = idx + off_x;
    float by = -(idy + off_y);
    float sum = 0.0f;

//    int proj[SUMS];
    float h[SUMS];
    float sums[SUMS] = {{0}};

    for(int p = 0; p < num_proj; p += SUMS) {
#pragma unroll 4
	for (int subp = 0; subp < SUMS; subp++) {
	    int proj = p + subp;
	    h[subp] = mad(by, all_table[proj].y, mad(bx, all_table[proj].x, all_table[proj].z)); 
	}

/*	
#pragma unroll 4
	for (int subp = 0; subp < SUMS; subp++) {
	    int proj = p + subp;
	    sums[subp] += read_imagef(sinogram, volumeSampler, (float2)(h[subp], proj + 0.5f)).x;
	}
*/
	sums[0] += read_imagef(sinogram, volumeSampler, (float2)(h[0], p + 0.5f)).x;
	sums[1] += read_imagef(sinogram, volumeSampler, (float2)(h[1], p + 1.5f)).x;
	sums[2] += read_imagef(sinogram, volumeSampler, (float2)(h[2], p + 2.5f)).x;
	sums[3] += read_imagef(sinogram, volumeSampler, (float2)(h[3], p + 3.5f)).x;

    }

// Can optimize with reduction
    for (int subp = 0; subp < SUMS; subp++)
	sum += sums[subp];

    slice[idy*slice_width + idx] = sum;
}


/**
 * Aims to place geometrically neighboring groups on the same SM (40 SMs per chip on R9-290)
 * Gave no speedup
 */
{
    const int num_bx = get_global_size(0) / get_local_size(0);
    const int num_by = get_global_size(1) / get_local_size(1);
    const int num_gid_blocks = num_bx * num_by / (4 * 40);
    
    const int gid = get_group_id(0) + get_group_id(1) * num_bx;
    const int gid_block = gid / (4 * 40);
    const int gid_item = gid % (4 * 40);
    const int gid_move = 40 * (gid_item / 40) + gid_item%40;
    const int gid_renum = gid_block * (4 * 40) + ((gid_block < num_gid_blocks)?gid_move:gid_item);

    const int gidx = gid_renum % num_bx;
    const int gidy = gid_renum / num_bx;
    
    
    const int num_x_blocks = num_bx / 16;
    const int num_y_blocks = num_by / 16;
    
    const int b_gidx = gidx / 16;
    const int x_gidx = gidx % 4;
    const int y_gidx = gidx / 4;

    const int b_gidy = gidy / 16;
    const int x_gidy = gidy % 4;
    const int y_gidy = gidy / 4;

    const int ngidx = 16 * b_gidx + 4 * x_gidy + x_gidx;
    const int ngidy = 16 * b_gidy + 4 * y_gidy + y_gidx;
    
    const int gidx2 = ((b_gidx < num_x_blocks)&&(b_gidy < num_y_blocks))?ngidx:gidx;
    const int gidy2 = ((b_gidx < num_x_blocks)&&(b_gidy < num_y_blocks))?ngidy:gidy;


    const int bidx = gidx2 * get_local_size(0);
    const int bidy = gidy2 * get_local_size(1);
}


/**
 * SimpleTex kernel. Needs multiplier on grid_size (we process only 16 pixels per group here)
 * I.e. number of blocks should be multipled by 4 in eachg direction,
 * Slower on R9-290
 * We still can streamline gmem writes, but I guess it is irrelevant here.
 */
__kernel void hst_backproject_kepler_tex(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all
) {
    float h;
    vfloat res = 0;

    volatile __local vfloat buf[16][16];

    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int bidx = get_group_id(0) * get_local_size(0) / 4;
    const int bidy = get_group_id(1) * get_local_size(1) / 4;

    const int slice_width = get_global_size(0) / 4;	// Scale by PPT if necessary
    const int slice_size = get_global_size(1) * slice_width / 4; // Scale by PPT if necessary

    const int proj_minor = tidx / 4;
    const int xy_minor = tidx % 4;
    const int y_minor = xy_minor / 2;
    const int x_minor = xy_minor % 2;

    const int proj_major = tidy / 4;
    const int xy_major = tidy % 4;
    const int y_major = xy_major / 2;
    const int x_major = xy_major % 2;

    const int proj = 4 * proj_major + proj_minor;
    const int sidy = y_major * 2 + y_minor;
    const int sidx = x_major * 2 + x_minor;

    const float x = bidx + sidx + off_x;
    const float y = bidy + sidy + off_y;
    const float projf = proj + 0.5f;


    const int tx = tidx % 4;
    const int ty = tidx / 4;
    const float x = bidx + tx + off_x;
    const float y = bidy + ty + off_y;
    
    for (int proje=0; proje<num_proj; proje+=16) {
	const float4 all = c_all[proje+proj];
//	const float4 all = {500.f + 0.1f * proje, -0.5f + 0.01f * proje, 0.8f - 0.01f * proje, 0.f};
//        h = all.z + x * all.x - y * all.y;
        h = mad(x, all.x, mad(y, -all.y, all.z));
	res += tex2d(sinogram, volumeSampler, (float2)(h, proje + projf));
//    	barrier(CLK_LOCAL_MEM_FENCE);
    }

    buf[4 * sidy + sidx][proj] = res;//[i][j];
    barrier(CLK_LOCAL_MEM_FENCE);

    for (int k=8; k>=1; k/=2) {
        buf[tidy][tidx] += buf[tidy][tidx+k];
    }
    vfloat val = buf[tidy][0];

    const int rx = /*4 * j +*/ tidy%4;
    const int ry = /*4 * i +*/ tidy/4;

    if (!tidx) {
	const int idx = bidx + rx;
	const int idy = bidy + ry;
	SET_SLICE(slice, idx, idy, val);
    }
}

/**
 * SimpleTex kernel. Needs multiplier on grid_size (we process only 16 pixels per group here)
 * I.e. number of blocks should be multipled by 4 in eachg direction,
 * We streamling access to const memory and helping to unroll tex requests in this version
 * Still slower on R9-290
 */
__kernel void hst_backproject_kepler_tex(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all
) {
    float h;
    vfloat res = 0;//[PPT][PPT] = {{0}};

    volatile __local vfloat buf[16][16];
    volatile __local float hbuf[4][16][4][4];

    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int bidx = get_group_id(0) * get_local_size(0) / 4;
    const int bidy = get_group_id(1) * get_local_size(1) / 4;

    const int slice_width = get_global_size(0) / 4;	// Scale by PPT if necessary
    const int slice_size = get_global_size(1) * slice_width / 4; // Scale by PPT if necessary

    const int proj_minor = tidx / 4;
    const int xy_minor = tidx % 4;
    const int y_minor = xy_minor / 2;
    const int x_minor = xy_minor % 2;

    const int proj_major = tidy / 4;
    const int xy_major = tidy % 4;
    const int y_major = xy_major / 2;
    const int x_major = xy_major % 2;

    const int proj = 4 * proj_major + proj_minor;
    const int sidy = y_major * 2 + y_minor;
    const int sidx = x_major * 2 + x_minor;

//    const float x = bidx + sidx + off_x;
//    const float y = bidy + sidy + off_y;
    const float projf = proj + 0.5f;


    const int tx = tidx % 4;
    const int ty = tidx / 4;
    const float x = bidx + tx + off_x;
    const float y = bidy + ty + off_y;
    
    for (int proje=0; proje<num_proj; proje+=64) {
#pragma unroll 4
	for (int p = 0; p < 64; p += 16) {
	    const float4 all = c_all[proje + p + tidy];
	    hbuf[p][tidy][ty][tx] = mad(x, all.x, mad(y, -all.y, all.z));
	}

        barrier(CLK_LOCAL_MEM_FENCE);

#pragma unroll 4
	for (int p = 0; p < 64; p += 16) {
	    res += tex2d(sinogram, volumeSampler, (float2)(hbuf[p][proj][sidy][sidx], proje + p + projf));
	}
        barrier(CLK_LOCAL_MEM_FENCE);
    }

    buf[4 * sidy + sidx][proj] = res;//[i][j];
    barrier(CLK_LOCAL_MEM_FENCE);
    for (int k=8; k>=1; k/=2) {
    	buf[tidy][tidx] += buf[tidy][tidx+k];
    }
    vfloat val = buf[tidy][0];

    const int rx = /*4 * j +*/ tidy%4;
    const int ry = /*4 * i +*/ tidy/4;
    if (!tidx) {
	const int idx = bidx + rx;
	const int idy = bidy + ry;
	SET_SLICE(slice, idx, idy, val);
    }
}


/**
 * Middle way between SimpleTex & Standard NewTex/KeplerTex kernels. 
 * Needs multiplier on grid_size (we process only 64 pixels per group here)
 * I.e. number of blocks should be multipled by 2 in eachg direction,
 * Still not faster on R9-290
 */

#define PPT 2
__kernel void hst_backproject_kepler_tex(const int num_proj, 
    const int num_bins, 
    const float off_x, 
    const float off_y, 
    __read_only image2d_t sinogram,
    __global float *slice,
    __constant float4 *c_all
) {
    float h;
    vfloat res[PPT][PPT] = {{0}};

    volatile __local vfloat buf[16][16];
    __local vfloat fin[4 * PPT][4 * PPT];

    const int tidx = get_local_id(0);
    const int tidy = get_local_id(1);

    const int bidx = get_group_id(0) * get_local_size(0) / (4 / PPT);
    const int bidy = get_group_id(1) * get_local_size(1) / (4 / PPT);

    const int slice_width = get_global_size(0) / (4 / PPT);	// Scale by PPT if necessary
    const int slice_size = get_global_size(1) * slice_width / (4 / PPT); // Scale by PPT if necessary

    const int proj_minor = tidx / 4;
    const int xy_minor = tidx % 4;
    const int y_minor = xy_minor / 2;
    const int x_minor = xy_minor % 2;

    const int proj_major = tidy / 4;
    const int xy_major = tidy % 4;
    const int y_major = xy_major / 2;
    const int x_major = xy_major % 2;

    const int proj = 4 * proj_major + proj_minor;
    const int sidy = y_major * 2 + y_minor;
    const int sidx = x_major * 2 + x_minor;

    const float x = bidx + sidx + off_x;
    const float y = bidy + sidy + off_y;
    const float projf = proj + 0.5f;


    for (int proje=0; proje<num_proj; proje += 16) {
        const float4 all = c_all[proje+proj];

//	const float4 all = {500.f + 0.1f * proje, -0.5f + 0.01f * proje, 0.8f - 0.01f * proje, 0.f};
//        h = all.z + x * all.x - y * all.y;
        h = mad(x, all.x, mad(y, -all.y, all.z));

#pragma unroll 2
        for (int i = 0; i < PPT; i++) {
#pragma unroll 2
	    for (int j = 0; j < PPT; j++) {
	        float subh = h + 4 * j * all.x - 4 * i * all.y;
		res[i][j] += tex2d(sinogram, linearSampler, (float2)(subh, proje + projf));
	    }
	}

//    	barrier(CLK_LOCAL_MEM_FENCE);
    }

/*
#pragma unroll 2
    for (int i = 0; i < PPT; i++) {
#pragma unroll 2
	for (int j = 0; j < PPT; j++) {

            buf[4 * sidy + sidx][proj] = res[i][j];

    	    barrier(CLK_LOCAL_MEM_FENCE);

            for (int k=8; k>=1; k/=2) {
        	buf[tidy][tidx] += buf[tidy][tidx+k];
	    }
            vfloat val = buf[tidy][0];

            const int rx = 4 * j + tidy%4;
            const int ry = 4 * i + tidy/4;

            if (!tidx) {
//		fin[ry][rx] = val;
		const int idx = bidx + rx;
		const int idy = bidy + ry;
		SET_SLICE(slice, idx, idy, val);
            }

    	    barrier(CLK_LOCAL_MEM_FENCE);

        }
    }
*/

/*
    const int idx = bidx + tidx;
    const int idy = bidy + tidy;
    SET_SLICE(slice, idx, idy, fin[tidy][tidx]);
*/

//    SET_SLICE(slice, idx, idy, ((float2){0,1}));

    if ((tidx < 8)&&(tidy < 8)) {
    const int idx = bidx + tidx;
    const int idy = bidy + tidy;
    SET_SLICE(slice, idx, idy, (res[0][1] + res[1][0] + res[1][1] + res[0][0]));
    }
}

